//
//  MainVC.m
//  TOSR_BLE
//
//  Created by jun on 2017/6/8.
//  Copyright © 2017年 leekey. All rights reserved.
//

#import "MainVC.h"
#import "SerialGATT.h"
#import "LBMenuView.h"
#import "BLEViewController.h"
#import "SettingViewController.h"
#import "ProgressHUD.h"

#import "NaviController.h"


#define BT_ASK_VERSION      200
#define BT_ASK_PASS         201
#define BT_ASK_WORKMODE     202
#define BT_ASK_STATUS       203

@interface MainVC ()<LBMenuViewDelegate,OnResultDelegate,UITextFieldDelegate,BTSmartSensorDelegate,BTViewDeviceSetDelegate>
{
    BOOL relayStatus[12];
    BOOL isTempMode;
    BOOL isTouchFlag[12];
    int sendMode;
    BOOL isMomentaryMode[12];
    BOOL isVersionBackData;
    NSMutableArray *buttons;
}

@property(nonatomic,strong) UIImage *left_h;
@property(nonatomic,strong) UIImage *left;

@property(nonatomic,strong) UIImage *middle_h;
@property(nonatomic,strong) UIImage *middle;

@property(nonatomic,strong) UIImage *right_h;
@property(nonatomic,strong) UIImage *right;

@property (strong, nonatomic) CBPeripheral *peripheral;
@property (strong, nonatomic) SerialGATT *sensor;
@property (strong, nonatomic) NSMutableArray *rssi_container;

@property(nonatomic,strong) UILabel *mStatus;
@property(nonatomic,strong) UIButton *btnTemp;


@property(nonatomic,strong) LBMenuView *menuView;
@property(nonatomic,strong) UIButton *settingBG;

@property(nonatomic,strong) NSArray *relayOnDatas;
@property(nonatomic,strong) NSArray *relayOffDatas;

@property(nonatomic,retain) NSTimer *relayTimer;

@end

@implementation MainVC


-(void)setUpView
{
    UIImageView *bg = [[UIImageView alloc]initWithImage:[UIImage imageNamed:@"bg"]];
    bg.frame = self.view.bounds;
    [self.view addSubview:bg];
    
    buttons = [NSMutableArray array];
    
    __weak typeof (self) weakSelf = self;
    
    UIView *topview = [[UIView alloc]init];
    topview.backgroundColor = RGB(99, 119, 133);
    [self.view addSubview:topview];
    [topview mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(weakSelf.view.mas_top);
        make.left.and.right.equalTo(weakSelf.view);
        make.height.mas_equalTo(@64);
    }];
    
    _mStatus = [[UILabel alloc]init];
    _mStatus.textColor = [UIColor whiteColor];
    _mStatus.text = @"Not connect";
    [topview addSubview:_mStatus];
    _mStatus.textAlignment = NSTextAlignmentRight;
    [_mStatus mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(topview.mas_right).with.offset(-20);
        make.left.equalTo(topview.mas_left).with.offset(20);
        make.height.mas_equalTo(@21);
        make.bottom.equalTo(topview.mas_bottom).with.offset(-10);
    }];
    
    
    UIImageView *top_logo = [[UIImageView alloc]initWithImage:[UIImage imageNamed:@"top_logo"]];
    top_logo.contentMode = UIViewContentModeScaleAspectFit;
    [self.view addSubview:top_logo];
    
    UILabel *logo_text= [[UILabel alloc]init];
    logo_text.text = @"Tinysine Electronics";
    logo_text.textColor =[UIColor whiteColor];
    logo_text.font = [UIFont systemFontOfSize:16.f];
    [self.view addSubview:logo_text];
    
    [top_logo mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(topview.mas_bottom).with.offset(20);
        make.left.equalTo(weakSelf.view).with.offset(20);
        make.width.mas_equalTo(@30);
        make.height.mas_equalTo(@23);
    }];
    
    [logo_text mas_makeConstraints:^(MASConstraintMaker *make) {
        make.height.mas_equalTo(@20);
        make.right.equalTo(weakSelf.view.mas_right);
        make.left.equalTo(top_logo.mas_right).with.offset(6);
        make.centerY.equalTo(top_logo.mas_centerY);
    }];
    
    
    UIView *line1 = [[UIView alloc]init];
    [self.view addSubview:line1];
    [line1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(top_logo.mas_bottom).with.offset(20);
        make.left.equalTo(weakSelf.view).with.offset(20);
        make.right.equalTo(weakSelf.view).with.offset(-20);
        make.height.mas_equalTo(@35);
    }];
    UIView *line2 = [[UIView alloc]init];
    [self.view addSubview:line2];
    [line2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(line1.mas_bottom).with.offset(20);
        make.left.equalTo(weakSelf.view).with.offset(20);
        make.right.equalTo(weakSelf.view).with.offset(-20);
        make.height.mas_equalTo(@35);
    }];
    
    UIView *line3 = [[UIView alloc]init];
    [self.view addSubview:line3];
    
    [line3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(line2.mas_bottom).with.offset(20);
        make.left.equalTo(weakSelf.view).with.offset(20);
        make.right.equalTo(weakSelf.view).with.offset(-20);
        make.height.mas_equalTo(@35);
    }];
    
    UIButton *relay1 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line1 addSubview:relay1];
    [buttons addObject:relay1];
    [relay1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.and.top.and.bottom.equalTo(line1);
        make.width.equalTo(line1).multipliedBy(0.25f);
    }];
    
    UIButton *relay2 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line1 addSubview:relay2];
    [buttons addObject:relay2];
    [relay2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.and.bottom.equalTo(line1);
        make.left.equalTo(relay1.mas_right);
        make.width.equalTo(relay1);
    }];
    UIButton *relay3 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line1 addSubview:relay3];
    [buttons addObject:relay3];
    [relay3 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.and.bottom.equalTo(line1);
        make.left.equalTo(relay2.mas_right);
        make.width.equalTo(relay2);
    }];
    UIButton *relay4 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line1 addSubview:relay4];
    [buttons addObject:relay4];
    [relay4 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.and.bottom.and.right.equalTo(line1);
        make.left.equalTo(relay3.mas_right);
    }];
    
    
    
    UIButton *relay5 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line2 addSubview:relay5];
    [buttons addObject:relay5];
    [relay5 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.and.top.and.bottom.equalTo(line2);
        make.width.equalTo(line2).multipliedBy(0.25f);
    }];
    
    UIButton *relay6 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line2 addSubview:relay6];
    [buttons addObject:relay6];
    [relay6 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.and.bottom.equalTo(line2);
        make.left.equalTo(relay5.mas_right);
        make.width.equalTo(relay5);
    }];
    UIButton *relay7 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line2 addSubview:relay7];
    [buttons addObject:relay7];
    [relay7 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.and.bottom.equalTo(line2);
        make.left.equalTo(relay6.mas_right);
        make.width.equalTo(relay6);
    }];
    UIButton *relay8 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line2 addSubview:relay8];
    [buttons addObject:relay8];
    [relay8 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.and.bottom.and.right.equalTo(line2);
        make.left.equalTo(relay7.mas_right);
    }];
    
    UIButton *relay9 = [UIButton buttonWithType:UIButtonTypeCustom];
    [line3 addSubview:relay9];
    [buttons addObject:relay9];
    [relay9 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.and.top.and.bottom.equalTo(line3);
        make.width.equalTo(line3).multipliedBy(0.25f);
    }];
    
    UIButton *relay10 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line3 addSubview:relay10];
    [buttons addObject:relay10];
    [relay10 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.and.bottom.equalTo(line3);
        make.left.equalTo(relay9.mas_right);
        make.width.equalTo(relay9);
    }];
    UIButton *relay11 = [UIButton buttonWithType:UIButtonTypeCustom];
    
    [line3 addSubview:relay11];
    [buttons addObject:relay11];
    [relay11 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.and.bottom.equalTo(line3);
        make.left.equalTo(relay10.mas_right);
        make.width.equalTo(relay10);
    }];
    UIButton *relay12 = [UIButton buttonWithType:UIButtonTypeCustom];

    [line3 addSubview:relay12];
    [buttons addObject:relay12];
    [relay12 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.and.bottom.and.right.equalTo(line3);
        make.left.equalTo(relay11.mas_right);
    }];
    
    int index = 0;
    for(;index<12;index++){
        UIButton *relay = buttons[index];
        [relay addTarget:self action:@selector(buttonUp:) forControlEvents:UIControlEventTouchUpInside];
        [relay addTarget:self action:@selector(buttonDown:) forControlEvents:UIControlEventTouchDown];
        relay.tag = 100+index;
        relay.titleLabel.font = [UIFont systemFontOfSize:14.f];
        if(index==0 || index == 4 || index == 8){
            [relay setBackgroundImage:_left forState:UIControlStateNormal];
            [relay setBackgroundImage:_left_h forState:UIControlStateHighlighted];
            [relay setBackgroundImage:_left_h forState:UIControlStateSelected];
        }else if(index== 3 || index == 7 || index == 11){
            [relay setBackgroundImage:_right forState:UIControlStateNormal];
            [relay setBackgroundImage:_right_h forState:UIControlStateHighlighted];
            [relay setBackgroundImage:_right_h forState:UIControlStateSelected];
        }else{
            [relay setBackgroundImage:_middle forState:UIControlStateNormal];
            [relay setBackgroundImage:_middle_h forState:UIControlStateHighlighted];
            [relay setBackgroundImage:_middle_h forState:UIControlStateSelected];
        }
    }
    
    UIButton *btnAllOn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btnAllOn setBackgroundImage:[UIImage imageNamed:@"all_on_normal"] forState:UIControlStateNormal];
    [btnAllOn setBackgroundImage:[UIImage imageNamed:@"all_on_pressed"] forState:UIControlStateHighlighted];
    [btnAllOn addTarget:self action:@selector(onAllOn:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:btnAllOn];
    
    
    
    UIButton *btnAllOff = [UIButton buttonWithType:UIButtonTypeCustom];
    [btnAllOff setBackgroundImage:[UIImage imageNamed:@"all_off_normal"] forState:UIControlStateNormal];
    [btnAllOff setBackgroundImage:[UIImage imageNamed:@"all_off_pressed"] forState:UIControlStateHighlighted];
    [btnAllOff addTarget:self action:@selector(onAllOff:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:btnAllOff];
    
    [btnAllOff mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(weakSelf.view.mas_right).with.offset(-20);
        make.top.equalTo(line3.mas_bottom).with.offset(30);
        make.width.mas_equalTo(@73);
        make.height.mas_equalTo(@27);
    }];
    
    [btnAllOn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(btnAllOff.mas_left).with.offset(-20);
        make.top.equalTo(line3.mas_bottom).with.offset(30);
        make.width.mas_equalTo(@73);
        make.height.mas_equalTo(@27);
    }];
    
    UIImageView *temIc = [[UIImageView alloc]initWithImage:[UIImage imageNamed:@"temp_icon"]];
    temIc.contentMode = UIViewContentModeScaleAspectFit;
    [self.view addSubview:temIc];
    
    
    UILabel *temLable = [[UILabel alloc]init];
    temLable.text = @"Temperature";
    temLable.textColor = [UIColor whiteColor];
    temLable.font = [UIFont systemFontOfSize:14.f];
    [self.view addSubview:temLable];
    
    _btnTemp = [UIButton buttonWithType:UIButtonTypeCustom];
    [_btnTemp setTitle:@"NC" forState:UIControlStateNormal];
    _btnTemp.titleLabel.font = [UIFont boldSystemFontOfSize:14.f];
    [_btnTemp setBackgroundImage:[UIImage imageNamed:@"temp_text_back"] forState:UIControlStateNormal];
    [_btnTemp addTarget:self action:@selector(onTempClick:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_btnTemp];
    
    [temIc mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(@28);
        make.height.mas_equalTo(@21);
        make.left.equalTo(weakSelf.view.mas_left).with.offset(20);
        make.top.equalTo(btnAllOn.mas_bottom).with.offset(20);
    }];

    [temLable mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(@108);
        make.height.mas_equalTo(@21);
        make.left.equalTo(temIc.mas_right).with.offset(5);
        make.centerY.equalTo(temIc.mas_centerY);
    }];
    [_btnTemp mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(weakSelf.view.mas_right).with.offset(-20);
        make.width.mas_equalTo(@143);
        make.height.mas_equalTo(@30);
        make.centerY.equalTo(temLable.mas_centerY);
    }];
    
}

- (void)viewDidLoad {
    [super viewDidLoad];
    _left_h = [UIImage imageNamed:@"btn_left_hl"];
    _left = [UIImage imageNamed:@"btn_left"];
    
    _middle_h = [UIImage imageNamed:@"btn_middle_hl"];
    _middle = [UIImage imageNamed:@"btn_middle"];
    
    _right_h = [UIImage imageNamed:@"btn_right_hl"];
    _right = [UIImage imageNamed:@"btn_right"];
    [self setUpView];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(applicationWillResignActive:)
                                                 name:UIApplicationWillResignActiveNotification object:nil];
    for (int i = 0; i < 12; i++) {
        relayStatus[i] = NO;
        isTouchFlag[i] = NO;
    }
    isTempMode = YES;
    
    _settingBG = [UIButton buttonWithType:UIButtonTypeCustom];
    _menuView = [LBMenuView menuView];
    _menuView.deletage = self;
    
    _relayOnDatas = @[@"65",@"66",@"67",@"68",@"69",@"6A",@"6B",@"6C",@"80",@"81",@"82",@"83"];
    _relayOffDatas = @[@"6f",@"70",@"71",@"72",@"73",@"74",@"75",@"76",@"90",@"91",@"92",@"93"];
    
    [self resetDefault];
}


//连接蓝牙
- (void)connectDevices{
    BLEViewController * bleViewController =[[BLEViewController alloc] init];
    bleViewController.delegate = self;
    NaviController *na = [[NaviController alloc]initWithRootViewController:bleViewController];
    [self presentViewController:na animated:YES completion:nil];
}


//选择蓝牙回调
- (void)didSelectDevice:(CBPeripheral*)per sensor:(SerialGATT*)sen{
    [self resetDefault];
    self.sensor = sen;
    self.sensor.delegate = self;
    [self.sensor connect:per];
    [ProgressHUD show:@"Connecting..."];
}


//连接成功回调
-(void)setConnect
{
    CFUUIDCreateString(kCFAllocatorDefault, (__bridge CFUUIDRef )self.sensor.activePeripheral.identifier);
    self.mStatus.text = self.sensor.activePeripheral.name;
    NSLog(@"=====连接成功===");
    [ProgressHUD show:@"Updating..."];
    [self askVersion];
}

//请求板卡信息，是否带密码
-(void)askVersion{
    NSLog(@"=====获取板卡状态===");
    [ProgressHUD show];
    sendMode = BT_ASK_VERSION;
    isVersionBackData = NO;
    [self sendHexValue:@"3C"];
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        dispatch_queue_t queue = dispatch_get_main_queue();
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(5 * NSEC_PER_SEC)), queue, ^{
            NSLog(@"=====获取板卡状态超时===");
            //5s板卡不回复，请求工作模式
            if(!isVersionBackData){
                NSLog(@"=====没有返回板卡状态===");
                [self askWorkMode];
            }
        });
    });
}

-(void)askWorkMode{
    NSLog(@"=====获取工作模式===");
    [ProgressHUD show];
    sendMode = BT_ASK_WORKMODE;
    [self sendHexValue:@"43"];
}

-(void)askStatus{
    NSLog(@"=====请求Relay状态===");
    [ProgressHUD show];
    [self startRelayTimer];
}

-(void)startRelayTimer{
    if(self.relayTimer){
        [self.relayTimer invalidate];
    }
    self.relayTimer = [NSTimer scheduledTimerWithTimeInterval:0.3 target:self selector:@selector(sendStatus) userInfo:nil repeats:YES];
}

-(void)stopRelayTimer{
    if(self.relayTimer){
        [self.relayTimer invalidate];
    }
}

- (void)sendStatus{
    NSLog(@"=====请求状态间隔请求===");
    sendMode = BT_ASK_STATUS;
    [self sendHexValue:@"44"];
}

//请求密码验证
-(void)askPass:(NSString*)pass{
    sendMode = BT_ASK_PASS;
    [self sendHexValue:pass];
    [ProgressHUD show:@"Verifying..."];
}

//断开连接回调
-(void)setDisconnect
{
    [self resetDefault];
}


//收到蓝牙数据
-(void) serialGATTCharValueUpdated:(NSString *)UUID value:(NSData *)data
{
    unsigned long len = [data length];
    printf("\n\n=返回数据长度==len = %ld\n",len);
    Byte *resultByte = (Byte*)[data bytes];
    if(sendMode == BT_ASK_STATUS){
        [ProgressHUD dismiss];
        if(len == 4){
            int high = resultByte[0];
            NSString *highBir = [self toBinarySystemWithDecimalSystem:high];
            NSArray *highDatas = [self reverseWordsInString:highBir];
            for (int index = 0; index < 8; index++) {
                if(index < highDatas.count){
                    int va = [highDatas[index] intValue];
                    relayStatus[index] = va ==1;
                }else{
                    relayStatus[index] = NO;
                }
            }
            int low = resultByte[1];
            NSString *lowBir = [self toBinarySystemWithDecimalSystem:low];
            NSArray *lowDatas = [self reverseWordsInString:lowBir];
            for(int index = 0;index < 4;index++){
                if(index < lowDatas.count){
                    int va = [lowDatas[index] intValue];
                    relayStatus[8+index] = va == 1;
                }else{
                    relayStatus[8+index] = NO;
                }
            }
            int msb = resultByte[2];
            int lsb = resultByte[3];
            if (msb == 0 && lsb == 0 ){
                [self.btnTemp setTitle:@"NC" forState:UIControlStateNormal];
            }else{
                int MSB = msb;
                int LSB = lsb;
                
                if( MSB > 127 ){
                    MSB = MSB - 256;
                }
                
                if(LSB > 127 ){
                    LSB = LSB - 256;
                }
                LSB = LSB < 0 ? LSB + 256 : LSB;
                float temp = ( MSB * 255 + LSB)/16.0;
                
                
                
                if(!isTempMode){
                    temp = (temp * 9) / 5 + 32;
                    NSString *tempValue = [NSString stringWithFormat:@"%.2f℉",temp];
                    [self.btnTemp setTitle:tempValue forState:UIControlStateNormal];
                }else{
                    NSString *tempValue = [NSString stringWithFormat:@"%.2f℃",temp];
                    [self.btnTemp setTitle:tempValue forState:UIControlStateNormal];
                }
            }
            [self updateStatus];
        }
    }else if(sendMode == BT_ASK_WORKMODE){
        NSLog(@"=====工作模式返回===");
        if(len==12){
            NSUserDefaults *user = [NSUserDefaults standardUserDefaults];
            for(int index = 0; index < 12; index++){
                int value = resultByte[index];
                BOOL isMom = value==66;
                isMomentaryMode[index] = isMom;
                [user setBool:isMom forKey:[NSString stringWithFormat:@"mode%d",index+100]];
            }
        }
        [self askStatus];
    }else if(sendMode == BT_ASK_PASS){
        [ProgressHUD dismiss];
        if(len == 1){
            int pass = resultByte[0];
            if(pass == 1){
                [self.view makeToast:@"Verify successful!"];
                [self askWorkMode];
            }else{
                [self showAlertWithMsg:@"Verify failed,password incrrect!Please reset your board!"];
            }
        }
    }else if(sendMode==BT_ASK_VERSION){
        isVersionBackData = YES;
        NSLog(@"=====板卡状态返回===");
        //板卡返回
        if(len == 1){
            int pass = resultByte[0];
            NSString *bir = [self toBinarySystemWithDecimalSystem:pass];
            NSArray *result = [self reverseWordsInString:bir];
            BOOL hasPass = [result[0] intValue] == 1;
            NSLog(@"=====板卡状态返回==密码=%@",result[0]);
            if(hasPass){
                [ProgressHUD dismiss];
                //弹出密码框
                [self popEditPassword];
            }else{
                //不带密码，请求板卡模式
                [self askWorkMode];
            }
        }else{
            [self askVersion];
        }
    }
}

/////////////////////////密码管理/////////////////
//弹出密码
-(void)popEditPassword
{
    sendMode = BT_ASK_PASS;
    UIAlertView *dialog = [[UIAlertView alloc] initWithTitle:@"Please input the password!" message:@"" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil,nil];
    [dialog setAlertViewStyle:UIAlertViewStylePlainTextInput];
    UITextField *filed = [dialog textFieldAtIndex:0];
    filed.delegate = self;
    dialog.tag = 200;
    filed.secureTextEntry = YES;
    [filed setKeyboardType:UIKeyboardTypeNumberPad];
    [dialog show];
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if(alertView.tag == 200){
        if(buttonIndex == 0){
            UITextField *input = [alertView textFieldAtIndex:0];
            NSString *value = input.text;
            if([value length] != 6){
                [self showAlertWithMsg:@"Password is 6 digits!"];
            }else{
                int result = [value intValue];
                NSString *hexStr = [self ToHex:result];
                NSString *tem2 = [[NSString alloc] initWithFormat:@"%@%@",[@"000000" substringToIndex:(6-[hexStr length])],hexStr];
                tem2 = [NSString stringWithFormat:@"3F%@%@%@",[tem2 substringWithRange:NSMakeRange(4, 2)],[tem2 substringWithRange:NSMakeRange(2, 2)],[tem2 substringWithRange:NSMakeRange(0, 2)]];
                [self askPass:tem2];
            }
        }
    }else if(alertView.tag == 300){
        [self popEditPassword];
    }
}

- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string
{
    if (string.length == 0)
        return YES;
    NSInteger existedLength = textField.text.length;
    NSInteger selectedLength = range.length;
    NSInteger replaceLength = string.length;
    if (existedLength - selectedLength + replaceLength > 6) {
        return NO;
    }
    return YES;
}

- (void)textFieldDidChange:(UITextField *)textField{
    if (textField.text.length > 6) {
        textField.text = [textField.text substringToIndex:6];
    }
}

/////////////////////密码结束



//发送数据
-(void)sendHexValue:(NSString*)hexString
{
    int j=0;
    Byte bytes[hexString.length/2];
    for(int i=0;i<[hexString length];i++)
    {
        int int_ch;
        
        unichar hex_char1 = [hexString characterAtIndex:i];
        int int_ch1;
        if(hex_char1 >= '0' && hex_char1 <='9')
            int_ch1 = (hex_char1-48)*16;
        else if(hex_char1 >= 'A' && hex_char1 <='F')
            int_ch1 = (hex_char1-55)*16;
        else
            int_ch1 = (hex_char1-87)*16;
        i++;
        
        unichar hex_char2 = [hexString characterAtIndex:i];
        int int_ch2;
        if(hex_char2 >= '0' && hex_char2 <='9')
            int_ch2 = (hex_char2-48);
        else if(hex_char2 >= 'A' && hex_char2 <='F')
            int_ch2 = hex_char2-55;
        else
            int_ch2 = hex_char2-87;
        int_ch = int_ch1+int_ch2;
        bytes[j] = int_ch;
        j++;
    }
    NSData *newData = [[NSData alloc] initWithBytes:bytes length:hexString.length/2];
    NSLog(@"newData=%@",newData);
    [self.sensor write:self.sensor.activePeripheral data:newData];
}


//切换模式
-(void)onSettingMode:(int)index mode:(BOOL)mode
{
    isMomentaryMode[index - 100] = mode;
    NSString *modekey = [NSString stringWithFormat:@"mode%d",index];
    [[NSUserDefaults standardUserDefaults] setBool:mode forKey:modekey];
    int va = index - 100;
    NSString *str = @"";
    if(va<10){
        str = [NSString stringWithFormat:@"%d",index-100];
    }else if(va == 10){
        str = @"A";
    }else if(va == 11){
        str = @"B";
    }
    NSString *sendData = [NSString stringWithFormat:@"4%@0%@",mode?@"2":@"1",str];
    NSLog(@"===mode Send = %@",sendData);
    [self sendHexValue:sendData];
}

-(void)updateRelaySetting{
    int index = 100;
    for (; index<112; index++) {
        UIButton *btnRelay = (UIButton*)[self.view viewWithTag:index];
        NSString *namekey = [NSString stringWithFormat:@"name%d",index];
        NSString *name = [[NSUserDefaults standardUserDefaults] objectForKey:namekey];
        if(name == nil || [name isEqualToString:@""]){
            name = [NSString stringWithFormat:@"Relay%d",index-100+1];
        }
        [btnRelay setTitle:name forState:UIControlStateNormal];
        NSString *modekey = [NSString stringWithFormat:@"mode%d",index];
        isMomentaryMode[index-100] = [[NSUserDefaults standardUserDefaults] boolForKey:modekey];
    }
}


- (IBAction)buttonUp:(id)sender {
    if (self.sensor.activePeripheral) {
        UIButton *button = (UIButton*)sender;
        NSLog(@"=on==>%ld",(long)button.tag);
        int index = (int)(button.tag - 100);
        if(isTouchFlag[index] && isMomentaryMode[index]){
            [self sendHexValue:_relayOffDatas[index]];
            [self startRelayTimer];
            isTouchFlag[index] = NO;
        }
    }
}
-(void)sendRelayData:(NSDictionary*)dict
{
    [self sendHexValue:@""];
    int index = [dict[@"index"] intValue];
    while(isTouchFlag[index]){
        [NSThread sleepForTimeInterval:0.25];
        if(isTouchFlag[index]){
            NSLog(@"==>sssss = data = %@",dict[@"data"]);
            [self sendHexValue:dict[@"data"]];
            [NSThread sleepForTimeInterval:0.3];
        }
    }
}

- (IBAction)buttonDown:(id)sender {
    if (self.sensor.activePeripheral) {
        UIButton *button = (UIButton*)sender;
        NSLog(@"=pressed==>%ld",(long)button.tag);
        int index = (int)(button.tag - 100);
        if(isMomentaryMode[index]){
            //MomentaryMode
            [self stopRelayTimer];
            isTouchFlag[index] = YES;
            NSDictionary *dict = @{
                                   @"index":@(index),
                                   @"data":_relayOnDatas[index]
                                   };
            NSThread *thread = [[NSThread alloc] initWithTarget:self selector:@selector(sendRelayData:) object:dict];
            [thread start];
        }else{
            //LatMode
            [self sendHexValue:[NSString stringWithFormat:@"%@",relayStatus[index]?_relayOffDatas[index]:_relayOnDatas[index]]];
        }
    }else{
        [self connectDevices];
    }
}

//设置回调
-(void)onModify
{
    [self updateRelaySetting];
}

//温度点击切换样式
- (IBAction)onTempClick:(id)sender {
    isTempMode = !isTempMode;
}

- (IBAction)onAllOn:(id)sender {
    if (self.sensor.activePeripheral) {
        [self sendHexValue:@"64"];
    }else{
        [self connectDevices];
    }
}
- (IBAction)onAllOff:(id)sender {
    if (self.sensor.activePeripheral) {
        [self sendHexValue:@"6E"];
    }else{
        [self connectDevices];
    }
}

////////////////////底部菜单//////////////
-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
{
    self.settingBG.frame = self.view.frame;
    self.settingBG.backgroundColor = [UIColor grayColor];
    self.settingBG.alpha = 0.0;
    [self.settingBG addTarget:self action:@selector(hideMenu:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:self.settingBG];
    
    self.menuView.frame = CGRectMake(0, self.view.height, self.menuView.width, self.menuView.height);
    [self.view addSubview:self.menuView];
    [self.view bringSubviewToFront:self.menuView];
    
    [UIView animateWithDuration:0.3 animations:^{
        self.settingBG.alpha = 0.2;
        self.menuView.frame = CGRectMake(0, self.view.height - self.menuView.height, self.menuView.width, self.menuView.height);
    } completion:^(BOOL finished) {
    }];
}
-(void)hideMenu:(UIButton*)btn
{
    [UIView animateWithDuration:0.3 animations:^{
        btn.alpha = 0;
        self.menuView.frame = CGRectMake(0, self.view.height, self.menuView.width, self.menuView.height);
    } completion:^(BOOL finished) {
        [self.menuView removeFromSuperview];
        [btn removeFromSuperview];
    }];
    
}
-(void)didSelectButton:(LBMenuView*)settingView menuType:(MENU_TYPE)menuType
{
    [self hideMenu:self.settingBG];
    if(menuType == MENU_TYPE_CONNECT){
        [self connectDevices];
    }else if(menuType == MENU_TYPE_DISCONNECT){
        [self resetDefault];
    }else if(menuType == MENU_TYPE_CONFIG){
        SettingViewController *set = [[SettingViewController alloc]init];
        set.delegate = self;
        NaviController *na = [[NaviController alloc]initWithRootViewController:set];
        [self presentViewController:na animated:YES completion:nil];
    }
}
////////////////////底部菜单结束//////////////


//恢复默认
-(void)resetDefault
{
    for (int i=0; i<12; i++) {
        relayStatus[i] = NO;
        isTouchFlag[i] = NO;
    }
    int index = 100;
    for (; index<112; index++) {
        NSString *modekey = [NSString stringWithFormat:@"mode%d",index];
        [[NSUserDefaults standardUserDefaults] setBool:NO forKey:modekey];
    }
    isTempMode = YES;
    [self updateStatus];
    [self updateRelaySetting];
    _mStatus.text = @"Not Connect";
    [self.btnTemp setTitle:@"NC" forState:UIControlStateNormal];
    sendMode = BT_ASK_VERSION;
    if(self.relayTimer){
        [self.relayTimer invalidate];
        self.relayTimer = nil;
    }
    
    if ([self.sensor activePeripheral]) {
        if (self.sensor.activePeripheral.state == CBPeripheralStateConnected) {
            [self.sensor.manager cancelPeripheralConnection:self.sensor.activePeripheral];
            self.sensor.activePeripheral = nil;
        }
    }
}

//更新按钮状态
- (void)updateStatus {
    for(int index =0;index<12;index++){
        UIButton *but = buttons[index];
        but.selected = relayStatus[index];
    }
}


////////////////其他信息///////////////
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self.navigationController setNavigationBarHidden:YES animated:animated];
}

- (void)applicationWillResignActive:(NSNotification *)notification
{
    [self resetDefault];
}

-(void)viewDidUnload{
    [super viewDidUnload];
    [[NSNotificationCenter defaultCenter] removeObserver:UIApplicationWillResignActiveNotification];
}

-(UIStatusBarStyle)preferredStatusBarStyle
{
    return UIStatusBarStyleLightContent;
}


@end
